//+------------------------------------------------------------------+
//|                       MAIN INDICATOR                             |
//|                Fratelli Intraday trading system                  |
//|            http://www.forexfactory.com/showthread.php?t=325942   |
//|                                                                  |
//|it is an all in one combination of the following indicators:      |
//|                                              SuperTrend.mq4 v1.2 |
//|                   Copyright  2008, Jason Robinson (jnrtrading). |
//|                                   http://www.spreadtrade2win.com |
//|EMA-Crossover_Signal.mq4                                          |
//|         Copyright  2005, Jason Robinson (jnrtrading)            |
//|                   http://www.jnrtading.co.uk                     |
//|                                                                  |
//|                                                                  |
//|                                                MA_In_Color.mq4   |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//| Modified from LSMA_In_Color to use any MA by Robert Hill         |  
//|                                                                  |
//|  Combination made by MickyMouse , mihai27@seznam.cz              |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+









#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 DarkGreen
#property indicator_color2 Red
#property indicator_color3 DarkGreen
#property indicator_color4 Red
#property indicator_color5 White
#property indicator_color6 White
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 1


double TrendUp[], TrendDown[];
extern int BARS = 300;
double BarUp[], BarDown[];
double BarUpo[], BarDownc[];
int changeOfTrend;
string s1_ = "Super Trend Candles Settings";
int Nbr_Periods = 10;
double Multiplier = 1.7;
int BarWidth = 1;
int CandleWidth = 3;
double CrossUp[];
double CrossDown[];
string s2_ = "Ema 2,15 cross settings";
int FasterEMA = 2;
int SlowerEMA = 15;
extern bool SoundON=true;
double alertTag;
double control=2147483647;

int    MAMode;
string strMAType;
extern string s4_ = "Trading Hours Settings";
extern int NumberOfDays = 5;
extern string Begin_1 = "06:10";
extern string End_1 = "16:30";
extern color Color_1 = DarkGray;
 bool HighRange = FALSE;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
  DeleteObjects();
   for (int l_count_0 = 0; l_count_0 < NumberOfDays; l_count_0++) {
      CreateObjects("PWT1" + l_count_0, Color_1);
      
      }
       Comment("");

   SetIndexBuffer(0, BarUpo);
   SetIndexBuffer(1, BarDownc);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,CandleWidth);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,CandleWidth);   
   SetIndexBuffer(2, BarUp);
   SetIndexBuffer(3, BarDown);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,BarWidth);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,BarWidth);  
   SetIndexStyle(4, DRAW_ARROW,EMPTY );
   SetIndexArrow(4, 233);
   SetIndexBuffer(4, CrossUp);
   SetIndexStyle(5, DRAW_ARROW, EMPTY);
   SetIndexArrow(5, 234);
   SetIndexBuffer(5, CrossDown);

   
   

   return(0);
  }
  



int deinit()
  {
    DeleteObjects();
   Comment("");

   return(0);
  }

void CreateObjects(string a_name_0, color a_color_8) {
   ObjectCreate(a_name_0, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   ObjectSet(a_name_0, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(a_name_0, OBJPROP_COLOR, a_color_8);
   ObjectSet(a_name_0, OBJPROP_BACK, TRUE);
}

void DeleteObjects() {
   for (int l_count_0 = 0; l_count_0 < NumberOfDays; l_count_0++) {
      ObjectDelete("PWT1" + l_count_0);
      
   }
}

int start()
  {
   
   int limit, i, flag, flagh, trend[5000];
   double up[5000], dn[5000], medianPrice, atr;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit=Bars-counted_bars;
   for (i = MathMax(BARS - IndicatorCounted(), 1); i >= 0; i--) {
      TrendUp[i] = EMPTY_VALUE;
      TrendDown[i] = EMPTY_VALUE;
      atr = iATR(NULL, 0, Nbr_Periods, i);
      medianPrice = (High[i]+Low[i])/2;     
      up[i]=medianPrice+(Multiplier*atr);      
      dn[i]=medianPrice-(Multiplier*atr);      
      trend[i]=1;
      double ld_24 = MathMax(Open[i], Close[i]);
      double ld_32 = MathMin(Open[i], Close[i]);
        
      if (Close[i]>up[i+1]) {
         trend[i]=1;
         if (trend[i+1] == -1) changeOfTrend = 1;
         
      }
      else if (Close[i]<dn[i+1]) {
         trend[i]=-1;
         if (trend[i+1] == 1) changeOfTrend = 1;       
      }
      else if (trend[i+1]==1) {
         trend[i]=1;
         changeOfTrend = 0;       
      }
      else if (trend[i+1]==-1) {
         trend[i]=-1;
         changeOfTrend = 0;
      }

      if (trend[i]<0 && trend[i+1]>0) {
         flag=1;        
      }
      else {
         flag=0;        
      }
      
      if (trend[i]>0 && trend[i+1]<0) {
         flagh=1;         
      }
      else {
         flagh=0;       
      }
      
      if (trend[i]>0 && dn[i]<dn[i+1])
         dn[i]=dn[i+1];
      
      if (trend[i]<0 && up[i]>up[i+1])
         up[i]=up[i+1];
      
      if (flag==1)
         up[i]=medianPrice+(Multiplier*atr);
         
      if (flagh==1)
         dn[i]=medianPrice-(Multiplier*atr);
              
      if (trend[i]==1) {
         TrendUp[i]= dn[i];
         BarUp[i] = High[i];
         BarDown[i] = Low[i];
         if (Close[i] > Open[i]){
         BarUpo[i] = Close[i];
         BarDownc[i] = Open[i];
         }   
         if (Close[i] < Open[i]){
         BarUpo[i] = Open[i];
         BarDownc[i] = Close[i];
         }   
         
         if (changeOfTrend == 1) {
            TrendUp[i+1] = TrendDown[i+1];
            changeOfTrend = 0;
         }
  
      }
      else if (trend[i]==-1) {
         TrendDown[i]=up[i];
         BarUp[i] = Low[i];
         BarDown[i] = High[i];
        if (Close[i] < Open[i]){
         BarUpo[i] = Close[i];
         BarDownc[i] = Open[i];
         }   
         if (Close[i] > Open[i]){
         BarUpo[i] = Open[i];
         BarDownc[i] = Close[i];
         } 
            
         if (changeOfTrend == 1) {
            TrendDown[i+1] = TrendUp[i+1];
            changeOfTrend = 0;
         }
 
      }
      int  counter;
   double fasterEMAnow, slowerEMAnow, fasterEMAprevious, slowerEMAprevious, fasterEMAafter, slowerEMAafter;
   double Range, AvgRange;
  

   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
         
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++) {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      fasterEMAnow = iMA(NULL, 0, FasterEMA, 0, MODE_LWMA, PRICE_CLOSE, i+1);
      fasterEMAprevious = iMA(NULL, 0, FasterEMA, 0, MODE_LWMA, PRICE_CLOSE, i+2);
     

      slowerEMAnow = iMA(NULL, 0, SlowerEMA, 0, MODE_LWMA, PRICE_CLOSE, i+1);
      slowerEMAprevious = iMA(NULL, 0, SlowerEMA, 0, MODE_LWMA, PRICE_CLOSE, i+2);
      
      
      if ((fasterEMAnow > slowerEMAnow) && (fasterEMAprevious < slowerEMAprevious) ) {
         CrossUp[i+1] = Low[i+1] - Range*0.5;
      }
      else if ((fasterEMAnow < slowerEMAnow) && (fasterEMAprevious > slowerEMAprevious) ) {
         CrossDown[i+1] = High[i+1] + Range*0.5;
      }
      
           if (SoundON==true && i==1 && CrossUp[i] > CrossDown[i] && alertTag!=Time[0]){
       Alert("EMA Cross Trend going Down on ",Symbol()," ",Period());
       alertTag = Time[0];
     }
     if (SoundON==true && i==1 && CrossUp[i] < CrossDown[i] && alertTag!=Time[0]){
       Alert("EMA Cross Trend going Up on ",Symbol()," ",Period());
       alertTag = Time[0];
       
         } 
           
      

     } 
      int l_datetime_12 = TimeCurrent();
   for (int l_count_16 = 0; l_count_16 < NumberOfDays; l_count_16++) {
      DrawObjects(l_datetime_12, "PWT1" + l_count_16, Begin_1, End_1);
     
      for (l_datetime_12 = decDateTradeDay(l_datetime_12); TimeDayOfWeek(l_datetime_12) > 5; l_datetime_12 = decDateTradeDay(l_datetime_12)) {
      }
   }
}

void DrawObjects(int ai_0, string a_name_4, string as_12, string as_20) {
   int l_str2time_28 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_12);
   int l_str2time_32 = StrToTime(TimeToStr(ai_0, TIME_DATE) + " " + as_20);
   int l_shift_52 = iBarShift(NULL, 0, l_str2time_28);
   int l_shift_56 = iBarShift(NULL, 0, l_str2time_32);
   double l_high_36 = High[iHighest(NULL, 0, MODE_HIGH, l_shift_52 - l_shift_56, l_shift_56)];
   double ld_44 = Low[iLowest(NULL, 0, MODE_LOW, l_shift_52 - l_shift_56, l_shift_56)];
   if (!HighRange) {
      l_high_36 = 0;
      ld_44 = 2.0 * ld_44;
   }
   ObjectSet(a_name_4, OBJPROP_TIME1, l_str2time_28);
   ObjectSet(a_name_4, OBJPROP_PRICE1, l_high_36);
   ObjectSet(a_name_4, OBJPROP_TIME2, l_str2time_32);
   ObjectSet(a_name_4, OBJPROP_PRICE2, ld_44);
}

int decDateTradeDay(int ai_0) {
   int li_4 = TimeYear(ai_0);
   int li_8 = TimeMonth(ai_0);
   int li_12 = TimeDay(ai_0);
   int l_hour_16 = TimeHour(ai_0);
   int l_minute_20 = TimeMinute(ai_0);
   li_12--;
   if (li_12 == 0) {
      li_8--;
      if (li_8 == 0) {
         li_4--;
         li_8 = 12;
      }
      if (li_8 == 1 || li_8 == 3 || li_8 == 5 || li_8 == 7 || li_8 == 8 || li_8 == 10 || li_8 == 12) li_12 = 31;
      if (li_8 == 2) {
         if (MathMod(li_4, 4) == 0.0) li_12 = 29;
         else li_12 = 28;
      }
      if (li_8 == 4 || li_8 == 6 || li_8 == 9 || li_8 == 11) li_12 = 30;
   }
   return (StrToTime(li_4 + "." + li_8 + "." + li_12 + " " + l_hour_16 + ":" + l_minute_20));

      WindowRedraw();
   return(0);


  }

